from math import log2


def power(x, y):
    ans = 1
    cnt = y
    mn = x
    while cnt > 0:
        if cnt % 2 == 0:
            mn *= mn
            cnt //= 2
        else:
            ans *= mn
            cnt -= 1
    return ans


def check(md):
    ans = 0
    for i in range(n):
        if md >= a[i]:
            if md - a[i] >= t[i]:
                if log2(m) < md - a[i] - t[i] + 1:
                    return False, -1
                ans += power(2, md - a[i] - t[i] + 1)
            else:
                ans += 1
            if ans > m:
                return False, -1
    return ans <= m, ans


def bin_find():
    l, r = 0, 1000000000000000000
    while r - l > 1:
        md = (r + l) // 2
        if check(md)[0]:
            l = md
        else:
            r = md
    return l


n, m = map(int, input().split())
a = list(map(int, input().split()))
t = list(map(int, input().split()))
t2 = bin_find()
if check(t2)[1] == m:
    print(t2)
else:
    print(-1)
# 4 11
# 3 5 1 10
# 2 9 2 13

# 13 124
# 5 6 8 8 1 6 4 6 4 7 10 3 9
# 5 2 10 5 2 1 1 4 8 3 4 1 9
